svn commit: r290927 - user/pho/stress2/misc

Peter Holm pho at FreeBSD.org
Mon Nov 16 10:20:21 UTC 2015


Author: pho
Date: Mon Nov 16 10:20:19 2015
New Revision: 290927
URL: https://svnweb.freebsd.org/changeset/base/290927

Log:
  Added two regression tests.
  
  Sponsored by:	EMC / Isilon storage division

Added:
  user/pho/stress2/misc/oom.sh   (contents, props changed)
  user/pho/stress2/misc/vmio.sh   (contents, props changed)

Added: user/pho/stress2/misc/oom.sh
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ user/pho/stress2/misc/oom.sh	Mon Nov 16 10:20:19 2015	(r290927)
@@ -0,0 +1,49 @@
+#!/bin/sh
+
+#
+# Copyright (c) 2015 EMC Corp.
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD$
+#
+
+# Test OOM killing.
+
+# https://people.freebsd.org/~pho/stress/log/kostik847.txt
+# Fixed by r290915 and r290917
+
+# Expect:
+# kernel: pid 5654 (sort), uid 0, was killed: out of swap space
+
+[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1
+[ `sysctl -n hw.physmem` -gt $(( 1 * 1024 * 1024 * 1024)) ] && 
+echo "RAM should be capped to 1GB for this test."
+[ `sysctl -n hw.physmem` -gt $(( 8 * 1024 * 1024 * 1024)) ] && exit 0
+[ `sysctl -n vm.swap_total` -gt 0 ] && { swapoff -a; off=1; }
+
+for i in `jot 4`; do
+	sort < /dev/zero &
+done
+wait
+[ -n "$off" ] && swapon -a

Added: user/pho/stress2/misc/vmio.sh
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ user/pho/stress2/misc/vmio.sh	Mon Nov 16 10:20:19 2015	(r290927)
@@ -0,0 +1,58 @@
+#!/bin/sh
+
+#
+# Copyright (c) 2015 EMC Corp.
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD$
+#
+
+# Out of swap seen with no swap disk:
+# dd 'if=/dev/zero' 'of=/var/tmp/diskimage.1' 'bs=1m' 'count=3427'
+# pid 598 (ntpd), uid 0, was killed: out of swap space
+# pid 656 (sendmail), uid 0, was killed: out of swap space
+# pid 659 (sendmail), uid 25, was killed: out of swap space
+# https://people.freebsd.org/~pho/stress/log/alan020.txt
+
+# Deadlock seen:
+# https://people.freebsd.org/~pho/stress/log/kostik845.txt
+# Fixed by r290920.
+
+. ../default.cfg
+
+[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1
+[ `sysctl -n hw.physmem` -gt $(( 8 * 1024 * 1024 * 1024)) ] && exit 0
+[ `swapinfo | wc -l` -eq 1 ] || { swapoff -a; off=1; }
+size=$((`sysctl -n hw.physmem` / 1024 / 1024))
+need=$((size * 2))
+d1=${diskimage}.1
+d2=${diskimage}.2
+rm -f $d1 $d2 || exit 1
+[ `df -k $(dirname $diskimage) | tail -1 | awk '{print int($4 / 1024)'}` -lt \
+    $need ] && printf "Need %d MB on %s.\n" $need `dirname $diskimage` && exit
+trap "rm -f $d1 $d2" EXIT INT
+dd if=/dev/zero of=$d1 bs=1m count=$size 2>&1 | \
+    egrep -v "records|transferred"
+cp $d1 $d2
+[ -n "$off" ] && swapon -a


More information about the svn-src-user mailing list